#include <iostream>
using namespace std;

int main()
{
    int N,M,Q,i=1,j=1,sum=0;
    int k=1;
    int l=2;
    cin>>N>>M;
    int a[N][M];
    for(int i=1;i<=N;i++){
        for(int j=1;j<=M;j++){
            cin>>a[i][j];
        }
    }
    
    cin>>Q;
    Q*=2;
    int s[Q];
    for(int i=1;i<=Q;i++){
        
            cin>>s[i];
        
        
    }
    int x=s[1];
    int y=s[2];
    int t=0;
    while(t<Q){
    
    while(a[i][j]!=a[N][M]){
        while(j<y){
            
            sum+=a[i][j];
            j++;
        }
        while(i<=N ){
                i++;
                sum+=a[i][j];
            }
        while(i==N && j<=M){
            j++;
            sum+=a[i][j];
        }
    }
    k+=2;
    l+=2;
    x=s[k];
    y=s[l];
    t++;
}
cout<<sum;
    return 0;
}